
IncludeFile "Include\FontMapSystem.pbi"

;---------------------------------------------------------------------------------------------------------------
; Nach dem Einbinden der Include "FontMapSystem.pbi" stehen nun folgende 4 Prozeduren zur Verfgung:
;
; 1) FontID = FontMapLoad(SpriteName$)   - ldt die angegebene Bitmap und ffnet automatisch das zugehrige Datenfile
; 2) Width  = FontMapWide(FontID, Text$) - Rckgabewert ist die Breite des Textes in Pixel
; 3) Height = FontMapHigh(FontID, Text$) - Rckgabewert ist die Hhe des Textes in Pixel
;
; 4) FontMapOutput(FontID, Text$, PosX, PosY, AlignH, AlignV, Color) - Ausgabe des Textes:
;
; Jeder ausgegebene Text besitzt eine Referenzkoordinate (PosX, PosY) an der der Text mit den
; Parametern 'AlignX' und 'AlignY' ausgerichtet werden kann. Folgende Mglichkeiten gibt es:
;
; AlignH = #FHL - horizontal linksbndig (LEFT)
; AlignH = #FHC - horizontal zentriert (CENTER)
; AlignH = #FHR - horizontal rechtsbndig (RIGHT)
;
; AlignV = #FVT - vertikal obenbndig (TOP)
; AlignV = #FVC - vertikal zentriert (CENTER)
; AlignV = #FVB - vertikal untenbndig (BOTTOM)
;
; Der Parameter 'Color' wird nur ausgewertet, wenn der Font eine vernderliche Farbe besitzt. Die Farbe kann
; ber die RGB(R,G,B)-Funktion oder eine Hexadezimale Zahl bergeben werden.
;---------------------------------------------------------------------------------------------------------------

InitMouse()
InitSprite()
InitKeyboard()

OpenScreen(800, 600, 16, "Fontsystem")

;---------------------------------------------------------------------------------------------------------------
;Vor dem Laden eines Fonts muss ein Screen erstellt worden sein!!
TestFont = FontMapLoad("Fonts\AgastLarge.bmp")
;---------------------------------------------------------------------------------------------------------------

Repeat
  
ExamineMouse()
ExamineKeyboard()
ClearScreen(128,128,128)

;---------------------------------------------------------------------------------------------------------------
;Ausgabe des Textes, zentriert ausgerichtet an der Mausposition mit der Farbe rot
FontMapOutput(TestFont, "Fontsystem for PureBasic", MouseX(), MouseY(), #FHC, #FVC, $0000FF)
;---------------------------------------------------------------------------------------------------------------

FlipBuffers()
  
Until KeyboardReleased(#PB_Key_Escape)
; ExecutableFormat=Windows
; DisableDebugger
; EOF