;======================================================
; Tomysoft Font Editor "FontMap" Version 1.24
; 2005 by Lebostein
;======================================================
; Mail: Tomysoft@gmx.de
; Page: http://home.arcor.de/tomysoft/
;======================================================
; Run only with PureBasic Version 3.93!!!
;======================================================

#Programm = "FontMap 1.24"
#Infomail = "Tomysoft@gmx.de"

#Quest = #PB_MessageRequester_YesNo |#MB_ICONQUESTION

UsePNGImageDecoder()
UsePNGImageEncoder()

#TS_FlatButton = $0000
#SPC = Chr(32)

;----------------------------------
; Anzeigetexte laden [OK]
;----------------------------------

Dim Message.s(500)

ReadFile(0, "LANGUAGE.TXT")

languageID = Val(Trim(ReadString()))

Repeat
line$ = ReadString()
code$ = Trim(StringField(line$, 1, Chr(124)))
text$ = Trim(StringField(line$, 1 + languageID, Chr(124)))
Message(Val(code$)) = text$
Until Eof(0)

CloseFile(0)

;----------------------------------
; Font-Variablen [OK]
;----------------------------------

#MINWID = 0004
#MAXPIX = 2048
#FIELDS = 0512

Structure font
  back.l
  over.l
  wide.w
  high.w
  numx.w
  numy.w
  lenx.w
  leny.w
EndStructure

Global font.font

Dim posi.w(#FIELDS, #FIELDS)
Dim char.w(#FIELDS, #FIELDS)

Structure way
  LI.W
  OB.W
  RE.W
  UN.W
EndStructure

Global BordMin.way

Dim BordLen.way(#FIELDS, #FIELDS)
Dim BordPos.way(#FIELDS, #FIELDS)

;----------------------------------
; Extension Variablen [OK]
;----------------------------------

#extcount = 1

Structure expic
  name.s
  info.s
  flag.l
EndStructure

Dim expic.expic(#extcount)

Procedure SetExtension(index, name.s, info.s, flag)
  expic(index)\name = name
  expic(index)\info = info
  expic(index)\flag = flag
EndProcedure

SetExtension(0, ".bmp", "BMP - Windows Standard Bitmap", #PB_ImagePlugin_BMP)
SetExtension(1, ".png", "PNG - Portable Network Graphic", #PB_ImagePlugin_PNG)

Global ImageMask$: For EX = 0 To #extcount: ImageMask$ + "*" + expic(EX)\name + "; ": Next EX

#exscr$ = ".scrp"
#exdat$ = ".font"

;----------------------------------
; Allgemeine Variablen [OK]
;----------------------------------

Global WindowID
Global ActiveExt
Global filename$
Global filepath$
Global imagpath$

filepath$ = "Fonts\"
imagpath$ = "Fonts\"

#programm$ = "NOTEPAD.EXE"

#IB = 4
#RM = 2

#sizewide = 20
#sizehigh = 20
#maxizoom = 8

#break$ = #SPC + Chr(124) + #SPC

#IDE_showcol = $00EEFF

;----------------------------------
; Editor-Variablen [OK]
;----------------------------------

Structure edit
  posx.w
  posy.w
  line.w
EndStructure

Global edit.edit

Structure show
  widx.w
  widy.w
  offx.w
  offy.w
  back.l
EndStructure

Global show.show

edit\line = 010
show\widx = 611
show\widy = 082
show\offx = 005
show\offy = 005
show\back = $C08000

;----------------------------------
; Fonts laden [OK]
;----------------------------------

FontID1 = LoadFont(0, "Arial", 11)
FontID2 = LoadFont(1, "Arial", 15, #PB_Font_Bold)

;----------------------------------
; Image-Konstanten [OK]
;----------------------------------

Enumeration
  #Image_Source
  #Image_Screen
  #Image_Editor
  #Image_Sample
  #Image_Farbe1
  #Image_Farbe2
  #Image_Ablage
EndEnumeration

;----------------------------------
; Fenster erstellen [OK]
;----------------------------------

#flags = #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered
WindowID = OpenWindow(0, 0, 0, 1008, 712, #flags, #Programm)

If WindowY() < 20: MoveWindow(WindowX(), 1): EndIf

;----------------------------------
; Mens anlegen [OK]
;----------------------------------

Enumeration
  #MID_CreaFont
  #MID_LoadFont
  #MID_SaveFont
  #MID_CreaScrp
  #MID_SaveMore
  #MID_SaveCopy
  #MID_ExitProg
  #MID_WidReset
  #MID_WidIdent
  #MID_WidAlign
  #MID_WidMatic
  #MID_AscReset
  #MID_AscMatic
  #MID_MapCutLI
  #MID_MapCutOB
  #MID_MapCutRE
  #MID_MapCutUN
  #MID_MapCutAR
  #MID_Optimize
  #MID_MakeFont
  #MID_OpenHelp
  #MID_OpenInfo
  #KEY_Taste_LI
  #KEY_Taste_OB
  #KEY_Taste_RE
  #KEY_Taste_UN
  #EXT_Optional
EndEnumeration

CreateMenu(0, WindowID)

MenuTitle(Message(010))
MenuItem(#MID_CreaFont, Message(011))
MenuItem(#MID_LoadFont, Message(012))
MenuBar()
OpenSubMenu(Message(018)): For EX = 0 To #extcount
MenuItem(#EXT_Optional + EX, expic(EX)\info): Next EX
CloseSubMenu()
MenuBar()
MenuItem(#MID_SaveFont, Message(013))
MenuItem(#MID_SaveMore, Message(015))
MenuItem(#MID_SaveCopy, Message(016))
MenuBar()
MenuItem(#MID_CreaScrp, Message(014))
MenuBar()
MenuItem(#MID_ExitProg, Message(017))
MenuTitle(Message(020))
OpenSubMenu(Message(040))
MenuItem(#MID_AscReset, Message(041))
MenuBar()
MenuItem(#MID_AscMatic, Message(042))
CloseSubMenu()
OpenSubMenu(Message(030))
MenuItem(#MID_WidReset, Message(031))
MenuBar()
MenuItem(#MID_WidIdent, Message(032))
MenuItem(#MID_WidAlign, Message(033))
MenuBar()
MenuItem(#MID_WidMatic, Message(034))
CloseSubMenu()
MenuBar()
OpenSubMenu(Message(050))
MenuItem(#MID_MapCutLI, Message(051))
MenuItem(#MID_MapCutOB, Message(052))
MenuItem(#MID_MapCutRE, Message(053))
MenuItem(#MID_MapCutUN, Message(054))
MenuBar()
MenuItem(#MID_MapCutAR, Message(055))
MenuBar()
MenuItem(#MID_Optimize, Message(056))
CloseSubMenu()
MenuTitle(Message(060))
MenuItem(#MID_MakeFont, Message(061))
MenuTitle(Message(080))
MenuItem(#MID_OpenHelp, Message(081))
MenuBar()
MenuItem(#MID_OpenInfo, Message(082))

AddKeyboardShortcut(0, #PB_Shortcut_Left,  #KEY_Taste_LI)
AddKeyboardShortcut(0, #PB_Shortcut_Up,    #KEY_Taste_OB)
AddKeyboardShortcut(0, #PB_Shortcut_Right, #KEY_Taste_RE)
AddKeyboardShortcut(0, #PB_Shortcut_Down,  #KEY_Taste_UN)

;----------------------------------
; Statuszeile [OK]
;----------------------------------

CreateStatusBar(0, WindowID)

AddStatusBarField(240)
AddStatusBarField(160)
AddStatusBarField(240)
AddStatusBarField(290)
AddStatusBarField(080)

;----------------------------------
; Fensterobjekte anlegen [OK]
;----------------------------------

Enumeration
  #GFR_Screen
  #GFR_Editor
  #GFR_Sample
  #GFR_Letter
  #GFR_Prefer
  #GIM_Screen
  #GIM_Editor
  #GIM_Sample
  #GBU_Slide_L
  #GBU_Slide_R
  #GBU_Slide_O
  #GBU_Slide_U
  #GBU_CharCuts
  #GBU_CharCopy
  #GBU_CharPast
  #GBU_CharEntf
  #GBU_LoadImage
  #GBU_Farbe1
  #GBU_Farbe2
  #GED_Sample
  #GTX_CharWide
  #GTX_CharText
  #GST_CharEdit
  #GTX_CharInfo
  #GBU_CharShow
  #GBU_WideShow
  #GTX_MeshNumx
  #GTX_MeshNumy
  #GTX_MeshWidx
  #GTX_MeshWidy
  #GST_MeshNumx
  #GST_MeshNumy
  #GST_MeshWidx
  #GST_MeshWidy
  #GBU_FresMesh
  #GTX_CharHori
  #GTX_CharVert
  #GSC_CharHori
  #GSC_CharVert
  #GBU_UseFront
  #GCH_BaseLine
  #GTB_Zooming
EndEnumeration

CreateGadgetList(WindowID)

ScrollAreaGadget  (#GFR_Screen,    006, 002, 621, 560, 0, 0, 10, #PB_ScrollArea_Single)
ImageGadget       (#GIM_Screen,    #IB, #IB, 000, 000, 0): CloseGadgetList()
ScrollAreaGadget  (#GFR_Editor,    641, 002, 310, 310, 0, 0, 10, #PB_ScrollArea_Single)
ImageGadget       (#GIM_Editor,    #IB, #IB, 000, 000, 0): CloseGadgetList()
Frame3DGadget     (#GFR_Sample,    006, 570, 621, 092, #Null$, #PB_Frame3D_Single)
ImageGadget       (#GIM_Sample,    011, 575, 000, 000, 0)
Frame3DGadget     (#GFR_Letter,    641, 318, 310, 052, Message(101))
Frame3DGadget     (#GFR_Prefer,    641, 375, 356, 187, Message(102))
ButtonGadget      (#GBU_Slide_L,   962, 023, 017, 025, Message(103), #TS_FlatButton)
ButtonGadget      (#GBU_Slide_R,   980, 023, 017, 025, Message(104), #TS_FlatButton)
ButtonGadget      (#GBU_Slide_O,   962, 002, 035, 020, Message(105), #TS_FlatButton)
ButtonGadget      (#GBU_Slide_U,   962, 049, 035, 020, Message(106), #TS_FlatButton)
ButtonGadget      (#GBU_CharCuts,  962, 110, 035, 020, Message(107), #TS_FlatButton)
ButtonGadget      (#GBU_CharCopy,  962, 135, 035, 020, Message(108), #TS_FlatButton)
ButtonGadget      (#GBU_CharPast,  962, 160, 035, 020, Message(109), #TS_FlatButton)
ButtonGadget      (#GBU_CharEntf,  962, 085, 035, 020, Message(110), #TS_FlatButton)
ButtonGadget      (#GBU_LoadImage, 650, 482, 338, 032, Message(111), #TS_FlatButton)
ButtonImageGadget (#GBU_Farbe1,    682, 521, 133, 032, 0)
ButtonImageGadget (#GBU_Farbe2,    823, 521, 165, 032, 0)
EditorGadget      (#GED_Sample,    641, 570, 356, 092)
TextGadget        (#GTX_CharWide,  651, 341, 125, 015, #Null$)
TextGadget        (#GTX_CharText,  778, 341, 072, 015, Message(112))
StringGadget      (#GST_CharEdit,  853, 332, 030, 030, #Null$)
TextGadget        (#GTX_CharInfo,  888, 341, 058, 015, #Null$)
TextGadget        (#GTX_MeshNumx,  651, 398, 060, 015, Message(113))
TextGadget        (#GTX_MeshNumy,  651, 418, 060, 015, Message(114))
TextGadget        (#GTX_MeshWidx,  651, 438, 060, 015, Message(115))
TextGadget        (#GTX_MeshWidy,  651, 458, 060, 015, Message(116))
StringGadget      (#GST_MeshNumx,  715, 395, 045, 020, #Null$, #PB_String_Numeric)
StringGadget      (#GST_MeshNumy,  715, 415, 045, 020, #Null$, #PB_String_Numeric)
StringGadget      (#GST_MeshWidx,  715, 435, 045, 020, #Null$, #PB_String_Numeric)
StringGadget      (#GST_MeshWidy,  715, 455, 045, 020, #Null$, #PB_String_Numeric)
ButtonGadget      (#GBU_FresMesh,  770, 395, 218, 032, Message(117), #TS_FlatButton)
ButtonGadget      (#GBU_CharShow,  962, 324, 035, 022, Message(118), #PB_Button_Toggle | #TS_FlatButton)
ButtonGadget      (#GBU_WideShow,  962, 348, 035, 022, Message(119), #PB_Button_Toggle | #TS_FlatButton)
TextGadget        (#GTX_CharHori,  880, 439, 108, 015, #Null$)
TextGadget        (#GTX_CharVert,  880, 459, 108, 015, #Null$)
ScrollBarGadget   (#GSC_CharHori,  770, 436, 100, 018, 0, #sizewide << 1, 1)
ScrollBarGadget   (#GSC_CharVert,  770, 456, 100, 018, 0, #sizehigh << 1, 1)
ButtonGadget      (#GBU_UseFront,  650, 521, 032, 032, #Null$, #PB_Button_Toggle | #TS_FlatButton)
TrackBarGadget    (#GTB_Zooming,   962, 190, 035, 090, 1, #maxizoom, #PB_TrackBar_Vertical | #PB_TrackBar_Ticks)
ButtonGadget      (#GCH_BaseLine,  962, 290, 035, 022, Message(122), #PB_Button_Toggle | #TS_FlatButton)

;----------------------------------
; Gadget Eigenschaften setzen [OK]
;----------------------------------

SetGadgetState    (#GTB_Zooming,   #maxizoom - 5 + 1)
SetGadgetFont     (#GST_CharEdit,  FontID2)
SetGadgetFont     (#GED_Sample,    FontID1)
SetGadgetText     (#GED_Sample,    Message(002))
GadgetToolTip     (#GBU_FresMesh,  Message(401))
GadgetToolTip     (#GBU_LoadImage, Message(402))
GadgetToolTip     (#GBU_CharCuts,  Message(403))
GadgetToolTip     (#GBU_CharCopy,  Message(404))
GadgetToolTip     (#GBU_CharPast,  Message(405))
GadgetToolTip     (#GBU_CharEntf,  Message(406))
GadgetToolTip     (#GBU_Slide_L,   Message(407))
GadgetToolTip     (#GBU_Slide_R,   Message(408))
GadgetToolTip     (#GBU_Slide_O,   Message(409))
GadgetToolTip     (#GBU_Slide_U,   Message(410))
GadgetToolTip     (#GBU_CharShow,  Message(411))
GadgetToolTip     (#GIM_Sample,    Message(412))
GadgetToolTip     (#GBU_UseFront,  Message(413))
GadgetToolTip     (#GBU_WideShow,  Message(414))
GadgetToolTip     (#GCH_BaseLine,  Message(415))

UpdateWindow_(WindowID)

;----------------------------------
; Prozeduren includen [OK]
;----------------------------------

IncludeFile "SOURCE_Procedures.pbi"

;----------------------------------
; Hauptschleife
;----------------------------------

FontNew()

UpdateComplete()

Repeat

  reset = 0
  event = WaitWindowEvent()
  etype = EventType()

  If event = #PB_Event_MoveWindow: reset = 1: EndIf
  If event = #PB_Event_CloseWindow: ende = 1: EndIf

  ;----------------------------------------------------------------
  If event = #PB_Event_Menu: For EX = 0 To #extcount
  ;----------------------------------------------------------------

  If EventMenuID() = #EXT_Optional + EX: reset = 1: ActiveExt = EX: EndIf

  ;----------------------------------------------------------------
  Next EX: EndIf
  ;----------------------------------------------------------------
  If event = #PB_Event_Menu: Select EventMenuID()
  ;----------------------------------------------------------------

  Case #MID_CreaFont  : reset = 1: FontNew()
  Case #MID_SaveFont  : reset = 1: FontSave(0)
  Case #MID_SaveMore  : reset = 1: FontSave(1)
  Case #MID_CreaScrp  : reset = 1: CreateScript()
  Case #MID_OpenHelp  : reset = 1: MessageRequester(Message(206), Message(207), #MB_ICONINFORMATION)
  Case #MID_OpenInfo  : reset = 1: MessageRequester(#Programm, #Infomail, #MB_ICONINFORMATION)
  Case #MID_LoadFont  : reset = 1: If FontLoadRequester(): FontLoad(): EndIf
  Case #MID_SaveCopy  : reset = 1: If FontSaveRequester(): FontSave(2): EndIf
  Case #KEY_Taste_LI  : reset = 1: edit\posx - 1: CheckPosition()
  Case #KEY_Taste_OB  : reset = 1: edit\posy - 1: CheckPosition()
  Case #KEY_Taste_RE  : reset = 1: edit\posx + 1: CheckPosition()
  Case #KEY_Taste_UN  : reset = 1: edit\posy + 1: CheckPosition()
  Case #MID_WidReset  : reset = 1: ToolSetWide(0, 0)
  Case #MID_WidIdent  : reset = 1: ToolSetWide(0, Val(InputRequester(Message(250), Message(251), Str(font\lenx))))
  Case #MID_WidAlign  : reset = 1: ToolSetWide(1, Val(InputRequester(Message(252), Message(253), #Null$)))
  Case #MID_WidMatic  : reset = 1: SearchFreePixel(): ToolAutoWide()
  Case #MID_AscReset  : reset = 1: ToolSetCode(0, 0)
  Case #MID_AscMatic  : reset = 1: ToolSetCode(1, Val(InputRequester(Message(254), Message(255), Str(32))))
  Case #MID_MapCutLI  : reset = 1: PX = Val(InputRequester(Message(256), Message(257), #Null$)): ToolReField(PX, 00, 00, 00)
  Case #MID_MapCutOB  : reset = 1: PX = Val(InputRequester(Message(256), Message(258), #Null$)): ToolReField(00, PX, 00, 00)
  Case #MID_MapCutRE  : reset = 1: PX = Val(InputRequester(Message(256), Message(259), #Null$)): ToolReField(00, 00, PX, 00)
  Case #MID_MapCutUN  : reset = 1: PX = Val(InputRequester(Message(256), Message(260), #Null$)): ToolReField(00, 00, 00, PX)
  Case #MID_MapCutAR  : reset = 1: PX = Val(InputRequester(Message(256), Message(265), #Null$)): ToolReField(PX, PX, PX, PX)
  Case #MID_Optimize  : reset = 1: SearchFreePixel(): ToolReField(-BordMin\LI, -BordMin\OB, -BordMin\RE, -BordMin\UN)
  Case #MID_MakeFont  : reset = 1: ToolCreateFromTTF()
  Case #MID_ExitProg  : reset = 1: ende = 1

  ;----------------------------------------------------------------
  EndSelect: EndIf
  ;----------------------------------------------------------------
  If event = #PB_EventGadget: Select EventGadgetID()
  ;----------------------------------------------------------------

  Case #GSC_CharHori  : reset = 1: font\wide = GetGadgetState(#GSC_CharHori) - #sizewide
  Case #GSC_CharVert  : reset = 1: font\high = GetGadgetState(#GSC_CharVert) - #sizehigh
  Case #GBU_FresMesh  : reset = 1: ImageRedimen()
  Case #GBU_LoadImage : reset = 1: ImageLoading()
  Case #GBU_Slide_L   : reset = 1: CharMov(-1, 0)
  Case #GBU_Slide_R   : reset = 1: CharMov( 1, 0)
  Case #GBU_Slide_O   : reset = 1: CharMov( 0,-1)
  Case #GBU_Slide_U   : reset = 1: CharMov( 0, 1)
  Case #GBU_CharCuts  : reset = 1: ClipboardCopy(): KillCharacter()
  Case #GBU_CharCopy  : reset = 1: ClipboardCopy()
  Case #GBU_CharPast  : reset = 1: ClipboardLoad()
  Case #GBU_CharEntf  : reset = 1: KillCharacter()
  Case #GBU_Farbe1    : reset = 1: ChangeColor(@font\over)
  Case #GBU_Farbe2    : reset = 1: ChangeColor(@font\back)
  Case #GBU_UseFront  : reset = 1: If font\over = #PB_Default: font\over = $FFFFFF: Else: font\over = #PB_Default: EndIf
  Case #GBU_CharShow  : reset = 1
  Case #GBU_WideShow  : reset = 1
  Case #GED_Sample    : reset = 1
  Case #GTB_Zooming   : reset = 1
  Case #GCH_BaseLine  : reset = 1

  ;----------------------------------------------------------------
  EndSelect: EndIf
  ;----------------------------------------------------------------
  If etype = #PB_EventType_LeftClick: Select EventGadgetID()
  ;----------------------------------------------------------------

  Case #GIM_Screen    : reset = 1: SetPosition()
  Case #GIM_Editor    : reset = 1: SetCharLength()
  Case #GIM_Sample    : reset = 1: ChangeColor(@show\back)

  ;----------------------------------------------------------------
  EndSelect: EndIf
  ;----------------------------------------------------------------
  If etype = #PB_EventType_LeftDoubleClick: Select EventGadgetID()
  ;----------------------------------------------------------------

  Case #GIM_Editor    : reset = 1: If GetGadgetState(#GCH_BaseLine) = 0: posi(edit\posx, edit\posy) = font\lenx: EndIf

  ;----------------------------------------------------------------
  EndSelect: EndIf
  ;----------------------------------------------------------------
  If etype = #PB_EventType_RightClick: Select EventGadgetID()
  ;----------------------------------------------------------------

  Case #GIM_Editor    : reset = 1: SetOverColor()

  ;----------------------------------------------------------------
  EndSelect: EndIf
  ;----------------------------------------------------------------
  If etype = #PB_EventType_Change: Select EventGadgetID()
  ;----------------------------------------------------------------

  Case #GST_CharEdit  : reset = 1: char(edit\posx, edit\posy) = Asc(GetGadgetText(#GST_CharEdit))

  ;----------------------------------------------------------------
  EndSelect: EndIf
  ;----------------------------------------------------------------

  If reset = 1: UpdateComplete(): EndIf: SetPositionStatus()

Until ende = 1
; ExecutableFormat=Windows
; EnableXP
; UseIcon=SOURCE_FontMap.ico
; Executable=D:\Leibelt\Dokumente\PureBasic\Projekte\FontMapSystem\FontMap.exe
; DisableDebugger
; EOF