;----------------------------------
; Colorhex [OK]
;----------------------------------

Procedure.s ColorHex(value)

  ProcedureReturn RSet(Hex(value), 6, Chr(48))

EndProcedure

;----------------------------------
; Wertzuweisung mit Min/Max [OK)
;----------------------------------

Procedure Limit(value, min, max)

  If value < min: value = min: EndIf
  If value > max: value = max: EndIf
  ProcedureReturn value

EndProcedure

;----------------------------------
; Ist Maus ber Gadget [OK]
;----------------------------------

Procedure GadgetMouseOver(GadgetID)

  GetCursorPos_(mouse.POINT)
  GetWindowRect_(GadgetID(GadgetID), rect.RECT)
  If mouse\x >= rect\LEFT And mouse\y >= rect\TOP And mouse\x < rect\RIGHT And mouse\y < rect\BOTTOM: result = 1: EndIf
  ProcedureReturn result

EndProcedure 

;----------------------------------
; Mausposition X [OK]
;----------------------------------

Procedure GadgetMouseX(GadgetID, BlockSize)

  GetCursorPos_(mouse.POINT)
  MapWindowPoints_(0, GadgetID(GadgetID), mouse, 1)
  ProcedureReturn Int(mouse\x / BlockSize)

EndProcedure

;----------------------------------
; Mausposition Y [OK]
;----------------------------------

Procedure GadgetMouseY(GadgetID, BlockSize)

  GetCursorPos_(mouse.POINT)
  MapWindowPoints_(0, GadgetID(GadgetID), mouse, 1)
  ProcedureReturn Int(mouse\y / BlockSize)

EndProcedure

;----------------------------------
; Fonts erstellen [OK]
;----------------------------------

Procedure FontDataNew()

  Dim posi.w(#FIELDS, #FIELDS)
  Dim char.w(#FIELDS, #FIELDS)

  filename$ = filepath$ + Message(001)

  font\back = $FF00FF
  font\over = #PB_Default
  font\wide = 00
  font\high = 00
  font\numx = 10
  font\numy = 06
  font\lenx = 32
  font\leny = 32

EndProcedure

;----------------------------------
; Fonts laden [OK]
;----------------------------------

Procedure FontDataLoad()

  Dim posi.w(#FIELDS, #FIELDS)
  Dim char.w(#FIELDS, #FIELDS)

  ReadFile(0, filename$ + #exdat$)

  font\back = ReadLong()
  font\over = ReadLong()
  font\wide = ReadWord()
  font\high = ReadWord()
  font\numx = ReadWord()
  font\numy = ReadWord()
  font\lenx = ReadWord()
  font\leny = ReadWord()

  For y = 1 To font\numy
  For x = 1 To font\numx

  char(x,y) = ReadWord()
  posi(x,y) = ReadWord()

  Next x
  Next y

  CloseFile(0)

EndProcedure

;----------------------------------
; Fonts speichern [OK]
;----------------------------------

Procedure FontDataSave()

  CreateFile(0, filename$ + #exdat$)

  WriteLong(font\back)
  WriteLong(font\over)
  WriteWord(font\wide)
  WriteWord(font\high)
  WriteWord(font\numx)
  WriteWord(font\numy)
  WriteWord(font\lenx)
  WriteWord(font\leny)

  For y = 1 To font\numy
  For x = 1 To font\numx

  WriteWord(char(x,y))
  WriteWord(posi(x,y))

  Next x
  Next y

  CloseFile(0)

EndProcedure

;----------------------------------
; TOMADE Script erzeugen [OK]
;----------------------------------

Procedure CreateScript()

  CreateFile(0, filename$ + #exscr$)

  text$ = "*load_sprite" + #break$
  text$ + "#SPR_" + GetFilePart(filename$) + #break$
  text$ + GetFilePart(filename$) + expic(ActiveExt)\name + #break$
  text$ + ColorHex(font\back) + #break$
  text$ + RSet(Str(0), 2, Chr(48)) + #break$
  text$ + RSet(Str(0), 2, Chr(48))
  WriteStringN(text$)

  WriteStringN(#Null$)

  text$ = "*crea_font" + #break$
  text$ + "#FNT_" + GetFilePart(filename$) + #break$
  text$ + "#SPR_" + GetFilePart(filename$) + #break$
  text$ + ColorHex(font\over) + #break$
  text$ + RSet(Str(font\lenx), 2, Chr(48)) + #break$
  text$ + RSet(Str(font\leny), 2, Chr(48)) + #break$
  text$ + RSet(Str(font\wide), 2, Chr(48)) + #break$
  text$ + RSet(Str(font\high), 2, Chr(48))
  WriteStringN(text$)

  For y = 1 To font\numy
  For x = 1 To font\numx

  text$ = "@font_char" + #break$
  text$ + "#FNT_" + GetFilePart(filename$) + #break$
  text$ + RSet(Str(char(x,y)), 3, Chr(48)) + #break$
  text$ + RSet(Str(x), 2, Chr(48)) + #break$
  text$ + RSet(Str(y), 2, Chr(48)) + #break$
  text$ + RSet(Str(posi(x,y)), 2, Chr(48))
  If char(x,y) And posi(x,y): WriteStringN(text$): EndIf

  Next x
  Next y

  CloseFile(0)

  RunProgram(#programm$, filename$ + #exscr$, #Null$)

EndProcedure

;----------------------------------
; Transparentes Image [OK]
;----------------------------------

Procedure DrawTransparentImage(OutputDC, Image, x, y, TransColor)

  ImageData = UseImage(Image)
  ImageList = ImageList_Create_(ImageWidth(), ImageHeight(), #ILC_COLORDDB | #ILC_MASK, 1, 0)
  ImageList_AddMasked_(ImageList, ImageData, TransColor)
  ImageList_Draw_(ImageList, 0, OutputDC, x, y, #ILD_TRANSPARENT)
  ImageList_Destroy_(ImageList)

EndProcedure

;----------------------------------
; Screen-Image Updaten [OK]
;----------------------------------

Procedure UpdateImageScreen()

  imagx = (font\lenx + #RM << 1) * font\numx
  imagy = (font\leny + #RM << 1) * font\numy

  CreateImage(#Image_Screen, imagx, imagy)

  UseImage(#Image_Screen)
  StartDrawing(ImageOutput())
  Box(0, 0, imagx, imagy, GetSysColor_(#COLOR_3DFACE))
  StopDrawing()

  For y = 1 To font\numy
  For x = 1 To font\numx

  If x = edit\posx And y = edit\posy: CharActiv = 1: Else: CharActiv = 0: EndIf
  If GetGadgetState(#GBU_WideShow): widex = posi(x,y): Else: widex = font\lenx: EndIf

  grabx = font\lenx * (x - 1)
  graby = font\leny * (y - 1)
  drawx = #RM + (font\lenx + #RM << 1) * (x - 1)
  drawy = #RM + (font\leny + #RM << 1) * (y - 1)

  ImageSource = GrabImage(#Image_Source, #PB_Any, grabx, graby, widex, font\leny)

  UseImage(#Image_Screen)
  StartDrawing(ImageOutput()): DrawingMode(0)
  If char(x,y) = 0 And GetGadgetState(#GBU_CharShow): Box(drawx, drawy, widex, font\leny, 0): DrawingMode(2): EndIf
  If widex > 0: DrawImage(UseImage(ImageSource), drawx, drawy): EndIf: DrawingMode(4)
  If CharActiv = 1: Box(drawx - 1, drawy - 1, font\lenx + 2, font\leny + 2, #IDE_showcol): EndIf
  If CharActiv = 1: Box(drawx - 2, drawy - 2, font\lenx + 4, font\leny + 4, #IDE_showcol): EndIf
  StopDrawing()

  FreeImage(ImageSource)

  Next x
  Next y

EndProcedure

;----------------------------------
; Editor-Image Updaten [OK]
;----------------------------------

Procedure UpdateImageEditor()

  posx = font\lenx * (edit\posx - 1)
  posy = font\leny * (edit\posy - 1)

  GrabImage(#Image_Source, #Image_Editor, posx, posy, font\lenx, font\leny)

  UseImage(#Image_Editor)
  StartDrawing(ImageOutput()): DrawingMode(2)
  If GetGadgetState(#GCH_BaseLine): Line(0, edit\line, font\lenx, 0, 0): EndIf
  DrawingMode(0): Line(posi(edit\posx, edit\posy), 0, 0, font\leny, #IDE_showcol)
  StopDrawing()

  zoomer = #maxizoom - GetGadgetState(#GTB_Zooming) + 1
  ResizeImage(#Image_Editor, font\lenx * zoomer, font\leny * zoomer, #PB_Image_Raw)

EndProcedure

;----------------------------------
; Beispiel-Image Updaten [OK]
;----------------------------------

Procedure UpdateImageSample()

  CreateImage(#Image_Sample, show\widx, show\widy)

  UseImage(#Image_Sample)
  StartDrawing(ImageOutput())
  Box(0, 0, show\widx, show\widy, show\back)
  StopDrawing()

  Dim stabe.w(255,2)

  For y = 1 To font\numy
  For x = 1 To font\numx

  stabe(char(x,y),0) = posi(x,y)
  stabe(char(x,y),1) = font\lenx * (x - 1)
  stabe(char(x,y),2) = font\leny * (y - 1)

  Next x
  Next y

  text$ = GetGadgetText(#GED_Sample)
  count = Len(text$) - 1
  movex = show\offx
  movey = show\offy

  For stabe = 0 To count

  code = PeekB(@text$ + stabe) & $FF
  
  If code = 13

  movex = show\offx
  movey + font\leny + font\high

  ElseIf stabe(code, 0)

  ImageSource = GrabImage(#Image_Source, #PB_Any, stabe(code, 1), stabe(code, 2), stabe(code, 0), font\leny)

  UseImage(#Image_Sample)
  OutputDC = StartDrawing(ImageOutput())
  DrawTransparentImage(OutputDC, ImageSource, movex, movey, font\back)
  StopDrawing()

  FreeImage(ImageSource)

  movex + stabe(code, 0) + font\wide

  EndIf

  Next stabe

  UseImage(#Image_Sample)
  StartDrawing(ImageOutput())
  DrawingMode(4)
  Box(0, 0, show\widx, show\widy, 0)
  StopDrawing()

EndProcedure

;----------------------------------
; Button-Images Updaten [OK]
;----------------------------------

Procedure UpdateImageFarbe1()

  widx = GadgetWidth(#GBU_Farbe1) - 10
  widy = GadgetHeight(#GBU_Farbe1) - 10

  color = font\over: If font\over = #PB_Default: color = $FFFFFF: EndIf

  CreateImage(#Image_Farbe1, widx, widy)
  UseImage(#Image_Farbe1)
  StartDrawing(ImageOutput())
  Box(0, 0, widx, widy, color)
  DrawingMode(4)
  Box(0, 0, widx, widy, 0)
  StopDrawing()

EndProcedure

;----------------------------------
; Button-Images Updaten [OK]
;----------------------------------

Procedure UpdateImageFarbe2()

  widx = GadgetWidth(#GBU_Farbe2) - 10
  widy = GadgetHeight(#GBU_Farbe2) - 10

  color = font\back: If font\back = #PB_Default: color = $FFFFFF: EndIf

  CreateImage(#Image_Farbe2, widx, widy)
  UseImage(#Image_Farbe2)
  StartDrawing(ImageOutput())
  Box(0, 0, widx, widy, color)
  DrawingMode(4)
  Box(0, 0, widx, widy, 0)
  StopDrawing()

EndProcedure

;----------------------------------
; Gadgets updaten [OK]
;----------------------------------

Procedure UpdateAllGadgets()

  mychar = char(edit\posx, edit\posy)
  myposi = posi(edit\posx, edit\posy)

  mywidx = font\lenx * font\numx
  mywidy = font\leny * font\numy

  If mychar = 0: infochar$ = Message(130)
  ElseIf mychar = 32: infochar$ = Message(131)
  Else: infochar$ = Message(132) + #SPC + Str(mychar): EndIf

  infoposi$ = Str(myposi): If myposi = font\lenx: infoposi$ + #SPC + Message(136): EndIf
  If font\over = #PB_Default: front = 0: over$ = Message(121): Else: front = 1: over$ = Message(120): EndIf
  zoomer = #maxizoom - GetGadgetState(#GTB_Zooming) + 1

  For EX = 0 To #extcount: SetMenuItemState(0, #EXT_Optional + EX, 0): Next EX
  SetMenuItemState(0, #EXT_Optional + ActiveExt, 1)

  SetGadgetState(#GIM_Screen, UseImage(#Image_Screen))
  SetGadgetState(#GIM_Editor, UseImage(#Image_Editor))
  SetGadgetState(#GIM_Sample, UseImage(#Image_Sample))
  SetGadgetState(#GBU_Farbe2, UseImage(#Image_Farbe2))
  SetGadgetState(#GBU_Farbe1, UseImage(#Image_Farbe1))

  SetGadgetState(#GSC_CharHori, font\wide + #sizewide)
  SetGadgetState(#GSC_CharVert, font\high + #sizehigh)

  SetGadgetState(#GBU_UseFront, front)
  SetGadgetText(#GBU_UseFront, over$)
  DisableGadget(#GBU_Farbe1, 1 - front)

  SetGadgetText(#GTX_CharHori, Message(133) + #SPC + Str(font\wide))
  SetGadgetText(#GTX_CharVert, Message(134) + #SPC + Str(font\high))
  SetGadgetText(#GTX_CharWide, Message(135) + #SPC + infoposi$)
  SetGadgetText(#GST_CharEdit, Chr(mychar))
  SetGadgetText(#GTX_CharInfo, infochar$)

  SetGadgetText(#GST_MeshNumx, Str(font\numx))
  SetGadgetText(#GST_MeshNumy, Str(font\numy))
  SetGadgetText(#GST_MeshWidx, Str(font\lenx))
  SetGadgetText(#GST_MeshWidy, Str(font\leny))

  GadgetToolTip(#GBU_Farbe1, Message(420) + #SPC + ColorHex(font\over))
  GadgetToolTip(#GBU_Farbe2, Message(421) + #SPC + ColorHex(font\back))
  GadgetToolTip(#GTB_Zooming, Message(422) + Str(zoomer))

  SetWindowTitle(0, #Programm + #SPC + Chr(45) + #SPC + filename$ + #exdat$)

  StatusBarText(0, 0, Message(304) + #SPC + expic(ActiveExt)\info)
  StatusBarText(0, 1, Message(302) + #SPC + Str(mywidx) + #SPC + Chr(120) + #SPC + Str(mywidy) + #SPC + Message(303))
  StatusBarText(0, 2, Message(301) + #SPC + Str(edit\posx) + Chr(44) + Str(edit\posy))
  StatusBarText(0, 3, #Null$)
  StatusBarText(0, 4, #Null$)

EndProcedure

;----------------------------------
; Scrollers updaten [OK]
;----------------------------------

Procedure UpdateScrollArea()

  Static Screen_x, Screen_y
  Static Editor_x, Editor_y

  UseImage(#Image_Screen): Image_x = ImageWidth(): Image_y = ImageHeight()

  If Screen_x <> Image_x Or Screen_y <> Image_y
  SetGadgetAttribute(#GFR_Screen, #PB_ScrollArea_InnerWidth, Image_x + #IB << 1)
  SetGadgetAttribute(#GFR_Screen, #PB_ScrollArea_InnerHeight, Image_y + #IB << 1)
  SetScrollPos_(GadgetID(#GFR_Screen), #SB_HORZ, 0, 1)
  SetScrollPos_(GadgetID(#GFR_Screen), #SB_VERT, 0, 1)
  Screen_x = Image_x: Screen_y = Image_y: EndIf

  UseImage(#Image_Editor): Image_x = ImageWidth(): Image_y = ImageHeight()

  If Editor_x <> Image_x Or Editor_y <> Image_y
  SetGadgetAttribute(#GFR_Editor, #PB_ScrollArea_InnerWidth, Image_x + #IB << 1)
  SetGadgetAttribute(#GFR_Editor, #PB_ScrollArea_InnerHeight, Image_y + #IB << 1)
  SetScrollPos_(GadgetID(#GFR_Editor), #SB_HORZ, 0, 1)
  SetScrollPos_(GadgetID(#GFR_Editor), #SB_VERT, 0, 1)
  Editor_x = Image_x: Editor_y = Image_y: EndIf

EndProcedure

;----------------------------------
; Alles Updaten [OK]
;----------------------------------

Procedure UpdateComplete()

  UpdateWindow_(WindowID)
  UpdateImageScreen()
  UpdateImageEditor()
  UpdateImageSample()
  UpdateImageFarbe1()
  UpdateImageFarbe2()
  UpdateAllGadgets()
  UpdateScrollArea()

EndProcedure

;----------------------------------
; Daten nach Zwischenablage [OK]
;----------------------------------

Procedure ClipboardCopy()

  posx = font\lenx * (edit\posx - 1)
  posy = font\leny * (edit\posy - 1)

  GrabImage(#Image_Source, #Image_Ablage, posx, posy, font\lenx, font\leny)
  SetClipboardData(#PB_ClipboardImage, UseImage(#Image_Ablage))

EndProcedure

;----------------------------------
; Daten von Zwischenablage [OK]
;----------------------------------

Procedure ClipboardLoad()

  posx = font\lenx * (edit\posx - 1)
  posy = font\leny * (edit\posy - 1)

  ImageCopyID = GetClipboardData(#PB_ClipboardImage)
  If ImageCopyID = 0: MessageRequester(Message(204), Message(205)): ProcedureReturn 0: EndIf

  ImageDestin = CreateImage(#PB_Any, font\lenx, font\leny)

  UseImage(ImageDestin)
  StartDrawing(ImageOutput())
  Box(0, 0, font\lenx, font\leny, font\back)
  DrawImage(ImageCopyID, 0, 0)
  StopDrawing()

  UseImage(#Image_Source)
  StartDrawing(ImageOutput())
  DrawImage(UseImage(ImageDestin), posx, posy)
  StopDrawing()

  FreeImage(ImageDestin)

EndProcedure

;----------------------------------
; Einen Buchstaben lschen [OK]
;----------------------------------

Procedure KillCharacter()

  posx = font\lenx * (edit\posx - 1)
  posy = font\leny * (edit\posy - 1)

  UseImage(#Image_Source)
  StartDrawing(ImageOutput())
  Box(posx, posy, font\lenx, font\leny, font\back)
  StopDrawing()

EndProcedure

;----------------------------------
; Transparente ermitteln [OK]
;----------------------------------

Procedure GetTransparentColor(ImageID)

  UseImage(ImageID)
  StartDrawing(ImageOutput())
  result = Point(0,0)
  StopDrawing()

  ProcedureReturn result

EndProcedure

;----------------------------------
; Hauptbild neu setzen [OK]
;----------------------------------

Procedure ImageSourceRefresh(ImageID, flag)

  font_widx = font\lenx * font\numx
  font_widy = font\leny * font\numy

  If flag: font\back = GetTransparentColor(ImageID): EndIf

  CreateImage(#Image_Source, font_widx, font_widy)

  UseImage(#Image_Source)
  StartDrawing(ImageOutput())
  Box(0, 0, font_widx, font_widy, font\back)
  DrawImage(UseImage(ImageID), 0, 0)
  StopDrawing()

EndProcedure

;----------------------------------
; Verschieben eines Images [OK]
;----------------------------------

Procedure CharMov(movx, movy)

  posx = font\lenx * (edit\posx - 1)
  posy = font\leny * (edit\posy - 1)

  ImageSource = GrabImage(#Image_Source, #PB_Any, posx, posy, font\lenx, font\leny)
  ImageDestin = CreateImage(#PB_Any, font\lenx, font\leny)

  UseImage(ImageDestin)
  StartDrawing(ImageOutput())
  DrawImage(UseImage(ImageSource), movx, movy)
  DrawImage(UseImage(ImageSource), movx + font\lenx, movy)
  DrawImage(UseImage(ImageSource), movx - font\lenx, movy)
  DrawImage(UseImage(ImageSource), movx, movy + font\leny)
  DrawImage(UseImage(ImageSource), movx, movy - font\leny)
  StopDrawing()

  UseImage(#Image_Source)
  StartDrawing(ImageOutput())
  DrawImage(UseImage(ImageDestin), posx, posy)
  StopDrawing()

  FreeImage(ImageDestin)
  FreeImage(ImageSource)

EndProcedure

;----------------------------------
; Grennderung eines Images [OK]
;----------------------------------

Procedure ImageRedimen()

  news_numx = Val(GetGadgetText(#GST_MeshNumx))
  news_numy = Val(GetGadgetText(#GST_MeshNumy))
  news_lenx = Val(GetGadgetText(#GST_MeshWidx))
  news_leny = Val(GetGadgetText(#GST_MeshWidy))

  If news_numx < 1: news_numx = 1: EndIf
  If news_numy < 1: news_numy = 1: EndIf
  If news_lenx < #MINWID: news_lenx = #MINWID: EndIf
  If news_leny < #MINWID: news_leny = #MINWID: EndIf

  news_char = news_numx * news_numy
  news_picx = news_numx * news_lenx
  news_picy = news_numy * news_leny

  If news_char > #FIELDS: MessageRequester(Message(261), Message(263) + #SPC + Str(#FIELDS)): ProcedureReturn 0: EndIf
  If news_picx > #MAXPIX: MessageRequester(Message(261), Message(264) + #SPC + Str(#MAXPIX)): ProcedureReturn 0: EndIf
  If news_picy > #MAXPIX: MessageRequester(Message(261), Message(264) + #SPC + Str(#MAXPIX)): ProcedureReturn 0: EndIf

  font\numx = news_numx
  font\numy = news_numy
  font\lenx = news_lenx
  font\leny = news_leny

  edit\posx = Limit(edit\posx, 1, font\numx)
  edit\posy = Limit(edit\posy, 1, font\numy)

  ImageSource = CopyImage(#Image_Source, #PB_Any)
  If ImageSource: ImageSourceRefresh(ImageSource, 1): FreeImage(ImageSource): EndIf

EndProcedure

;----------------------------------
; Bilddatei laden [OK]
;----------------------------------

Procedure ImageLoading()

  pattern$ = ImageMask$ + Chr(124) + ImageMask$

  datei$ = OpenFileRequester(Message(201), imagpath$, pattern$, 0)
  If datei$ = Space(0) Or FileSize(datei$) < 1: ProcedureReturn 0: EndIf
  imagpath$ = GetPathPart(datei$)

  ImageSource = LoadImage(#PB_Any, datei$)
  If ImageSource: ImageSourceRefresh(ImageSource, 1): FreeImage(ImageSource): EndIf

  For EX = 0 To #extcount

  ExtensionPart$ = Chr(46) + GetExtensionPart(datei$)
  If ExtensionPart$ = expic(EX)\name: ActiveExt = EX: Break: EndIf

  Next EX

EndProcedure

;----------------------------------
; Neuen Font anlegen [OK]
;----------------------------------

Procedure FontNew()

  FontDataNew()

  edit\posx = 1
  edit\posy = 1
  edit\line = font\leny - 1

  ImageSource = CreateImage(#PB_Any, font\lenx * font\numx, font\leny * font\numy)
  If ImageSource: ImageSourceRefresh(ImageSource, 1): FreeImage(ImageSource): EndIf

  ActiveExt = 0

EndProcedure

;----------------------------------
; Font einladen [OK]
;----------------------------------

Procedure FontLoad()

  FontDataLoad()

  edit\posx = 1
  edit\posy = 1
  edit\line = font\leny - 1

  For EX = 0 To #extcount

  ImageSource = LoadImage(#PB_Any, filename$ + expic(EX)\name)
  If ImageSource: ImageSourceRefresh(ImageSource, 0): FreeImage(ImageSource): ActiveExt = EX: Break: EndIf

  Next EX

EndProcedure

;----------------------------------
; Font abspeichern [OK]
;----------------------------------

Procedure FontSave(Switch)

  FontDataSave()

  If Switch = 0: ProcedureReturn 0: EndIf
  If Switch = 1 And MessageRequester(expic(ActiveExt)\info, Message(203), #Quest) <> 6: ProcedureReturn 0: EndIf

  SaveImage(0, filename$ + expic(ActiveExt)\name, expic(ActiveExt)\flag)

EndProcedure

;----------------------------------
; Farbe ndern [OK]
;----------------------------------

Procedure ChangeColor(adress)

  ColorOld = PeekL(adress)
  ColorNew = ColorRequester(ColorOld)
  If ColorNew <> #PB_Default: PokeL(adress, ColorNew): EndIf

EndProcedure

;----------------------------------
; Font Lade-Auswahl [OK]
;----------------------------------

Procedure FontLoadRequester()

  maske$ = Chr(42) + #exdat$
  pattern$ = maske$ + Chr(124) + maske$

  datei$ = OpenFileRequester(Message(220), filepath$, pattern$, 0)
  If datei$ = Space(0) Or FileSize(datei$) < 1: ProcedureReturn 0: EndIf
  filepath$ = GetPathPart(datei$)
  filename$ = filepath$ + RemoveString(GetFilePart(datei$), #exdat$, 1)
  ProcedureReturn 1

EndProcedure

;----------------------------------
; Font Save-Auswahl [OK]
;----------------------------------

Procedure FontSaveRequester()

  maske$ = Chr(42) + #exdat$
  pattern$ = maske$ + Chr(124) + maske$

  datei$ = SaveFileRequester(Message(221), filename$, pattern$, 0)
  If datei$ = Space(0): ProcedureReturn 0: EndIf
  filepath$ = GetPathPart(datei$)
  filename$ = filepath$ + RemoveString(GetFilePart(datei$), #exdat$, 1)
  ProcedureReturn 1

EndProcedure

;----------------------------------
; Prfen der Auswahl [OK]
;----------------------------------

Procedure CheckPosition()

  If edit\posx < 1: edit\posx = font\numx: edit\posy - 1: EndIf
  If edit\posx > font\numx: edit\posx = 1: edit\posy + 1: EndIf

  If edit\posy < 1: edit\posy = font\numy: EndIf
  If edit\posy > font\numy: edit\posy = 1: EndIf

EndProcedure

;----------------------------------
; Setzen der Pos-Info [OK]
;----------------------------------

Procedure SetPositionStatus()

  If GadgetMouseOver(#GIM_Editor)
  zoom = #maxizoom - GetGadgetState(#GTB_Zooming) + 1
  posx = GadgetMouseX(#GIM_Editor, zoom)
  posy = GadgetMouseY(#GIM_Editor, zoom)
  txt$ = message(305) + #SPC + Str(posx) + Chr(44) + Str(posy)
  EndIf: StatusBarText(0, 3, txt$)

EndProcedure

;----------------------------------
; Setzen der Auswahl [OK]
;----------------------------------

Procedure SetPosition()

  edit\posx = GadgetMouseX(#GIM_Screen, font\lenx + #RM << 1) + 1
  edit\posy = GadgetMouseY(#GIM_Screen, font\leny + #RM << 1) + 1

EndProcedure

;----------------------------------
; Setzen der Buchstabenlnge [OK]
;----------------------------------

Procedure SetCharLength()

  zoomer = #maxizoom - GetGadgetState(#GTB_Zooming) + 1
  pointx = GadgetMouseX(#GIM_Editor, zoomer)
  pointy = GadgetMouseY(#GIM_Editor, zoomer)

  If GetGadgetState(#GCH_BaseLine): edit\line = pointy: Else: posi(edit\posx, edit\posy) = pointx: EndIf

EndProcedure

;----------------------------------
; Setzen der Vordergrundfarbe [OK]
;----------------------------------

Procedure SetOverColor()

  zoomer = #maxizoom - GetGadgetState(#GTB_Zooming) + 1
  pointx = font\lenx * (edit\posx - 1) + GadgetMouseX(#GIM_Editor, zoomer)
  pointy = font\leny * (edit\posy - 1) + GadgetMouseY(#GIM_Editor, zoomer)

  UseImage(#Image_Source)
  StartDrawing(ImageOutput())
  font\over = Point(pointx, pointy)
  StopDrawing()

EndProcedure

;----------------------------------
; Abstnde ermitteln [OK]
;----------------------------------

Procedure SearchFreePixel()

  StatusBarText(0, 4, Message(300))

  BordMin\LI = font\lenx
  BordMin\OB = font\leny
  BordMin\RE = font\lenx
  BordMin\UN = font\leny

  For y = 1 To font\numy
  For x = 1 To font\numx

  posx = font\lenx * (x - 1)
  posy = font\leny * (y - 1)

  ImageSource = GrabImage(#Image_Source, #PB_Any, posx, posy, font\lenx, font\leny)

  UseImage(ImageSource)
  StartDrawing(ImageOutput())

  BordPos(x,y)\LI = font\lenx - 1
  BordPos(x,y)\OB = font\leny - 1
  BordPos(x,y)\RE = 0
  BordPos(x,y)\UN = 0

  For py = 0 To font\leny - 1
  For px = 0 To font\lenx - 1

  If Point(px,py) = font\back: Continue: EndIf

  If px < BordPos(x,y)\LI: BordPos(x,y)\LI = px: EndIf
  If py < BordPos(x,y)\OB: BordPos(x,y)\OB = py: EndIf
  If px > BordPos(x,y)\RE: BordPos(x,y)\RE = px: EndIf
  If py > BordPos(x,y)\UN: BordPos(x,y)\UN = py: EndIf

  Next px
  Next py

  StopDrawing()

  FreeImage(ImageSource)

  BordLen(x,y)\LI = BordPos(x,y)\LI
  BordLen(x,y)\OB = BordPos(x,y)\OB
  BordLen(x,y)\RE = font\lenx - BordPos(x,y)\RE - 1
  BordLen(x,y)\UN = font\leny - BordPos(x,y)\UN - 1

  If BordLen(x,y)\LI < BordMin\LI: BordMin\LI = BordLen(x,y)\LI: EndIf
  If BordLen(x,y)\OB < BordMin\OB: BordMin\OB = BordLen(x,y)\OB: EndIf
  If BordLen(x,y)\RE < BordMin\RE: BordMin\RE = BordLen(x,y)\RE: EndIf
  If BordLen(x,y)\UN < BordMin\UN: BordMin\UN = BordLen(x,y)\UN: EndIf

  Next x
  Next y

EndProcedure

;----------------------------------
; Tool Zeichencode setzen [OK]
;----------------------------------

Procedure ToolSetCode(switch, value)

  For y = 1 To font\numy
  For x = 1 To font\numx

  If switch = 0: char(x,y) = value: EndIf
  If switch = 1: char(x,y) = value: value + 1: EndIf

  char(x,y) = Limit(char(x,y), 0, 127)
  If char(x,y) = 127: char(x,y) = 0: EndIf

  Next x
  Next y

EndProcedure

;----------------------------------
; Tool Zeichenbreite setzen [OK]
;----------------------------------

Procedure ToolSetWide(switch, value)

  For y = 1 To font\numy
  For x = 1 To font\numx

  If switch = 0: posi(x,y) = value: EndIf
  If switch = 1: posi(x,y) + value: EndIf

  posi(x,y) = Limit(posi(x,y), 0, font\lenx)
  If char(x,y) = 0: posi(x,y) = 0: EndIf

  Next x
  Next y

EndProcedure

;----------------------------------
; Tool Zeichenbreite auto [OK]
;----------------------------------

Procedure ToolAutoWide()

  For y = 1 To font\numy
  For x = 1 To font\numx

  If char(x,y) <> 32: posi(x,y) = 0: EndIf
  If BordPos(x,y)\RE >= BordPos(x,y)\LI: posi(x,y) = BordPos(x,y)\RE + 1: EndIf
  If char(x,y) = 32 And posi(x,y) = 0: posi(x,y) = font\lenx / 3: EndIf
  If char(x,y) = 0: posi(x,y) = 0: EndIf

  Next x
  Next y

EndProcedure

;----------------------------------
; Tool Feldgre ndern [OK]
;----------------------------------

Procedure ToolReField(LI, OB, RE, UN)

  news_lenx = font\lenx + LI + RE
  news_leny = font\leny + OB + UN
  news_picx = font\numx * news_lenx
  news_picy = font\numy * news_leny

  If news_lenx < #MINWID: MessageRequester(Message(261), Message(262) + #SPC + Str(#MINWID)): ProcedureReturn 0: EndIf
  If news_leny < #MINWID: MessageRequester(Message(261), Message(262) + #SPC + Str(#MINWID)): ProcedureReturn 0: EndIf
  If news_picx > #MAXPIX: MessageRequester(Message(261), Message(264) + #SPC + Str(#MAXPIX)): ProcedureReturn 0: EndIf
  If news_picy > #MAXPIX: MessageRequester(Message(261), Message(264) + #SPC + Str(#MAXPIX)): ProcedureReturn 0: EndIf

  ImageDestin = CreateImage(#PB_Any, news_lenx * font\numx, news_leny * font\numy)
  ImageGround = CreateImage(#PB_Any, news_lenx, news_leny)

  For y = 1 To font\numy
  For x = 1 To font\numx

  olds_posx = font\lenx * (x - 1)
  olds_posy = font\leny * (y - 1)

  news_posx = news_lenx * (x - 1)
  news_posy = news_leny * (y - 1)

  ImageLetter = GrabImage(#Image_Source, #PB_Any, olds_posx, olds_posy, font\lenx, font\leny)

  UseImage(ImageGround)
  StartDrawing(ImageOutput())
  Box(0, 0, news_lenx, news_leny, font\back)
  DrawImage(UseImage(ImageLetter), LI, OB)
  StopDrawing()

  UseImage(ImageDestin)
  StartDrawing(ImageOutput())
  DrawImage(UseImage(ImageGround), news_posx, news_posy)
  StopDrawing()

  FreeImage(ImageLetter)

  Next x
  Next y

  CopyImage(ImageDestin, #Image_Source)

  FreeImage(ImageGround)
  FreeImage(ImageDestin)

  font\lenx = news_lenx
  font\leny = news_leny

  ToolSetWide(1, LI): edit\line + OB

EndProcedure

;----------------------------------
; Tool Schriftart erstellen [OK]
;----------------------------------

Procedure ToolCreateFromTTF()

  SelectFont = FontRequester("Times New Roman", 16, 0)
  If SelectFont = 0: ProcedureReturn 0: EndIf

  Length = SelectedFontSize()
  FontID = LoadFont(#PB_Any, SelectedFontName(), Length, SelectedFontStyle())

  Dim posi.w(#FIELDS, #FIELDS)
  Dim char.w(#FIELDS, #FIELDS)

  font\back = 0
  font\over = $FFFFFF
  font\wide = 0
  font\high = 0
  font\numx = 16
  font\numy = 14
  font\lenx = Length << 1 + Length >> 1
  font\leny = Length << 1 + Length >> 1

  CreateImage(#Image_Source, font\numx * font\lenx, font\numy * font\leny)

  UseImage(#Image_Source)
  StartDrawing(ImageOutput())
  DrawingMode(1)
  DrawingFont(UseFont(FontID))
  FrontColor(Red(font\over), Green(font\over), Blue(font\over))
  CodeCounter = 32
  For y = 1 To font\numy
  For x = 1 To font\numx
  posx = (x - 1) * font\lenx + Length >> 1
  posy = (y - 1) * font\leny + Length >> 1
  Locate(posx, posy)
  text$ = Chr(CodeCounter)
  DrawText(text$)
  char(x,y) = CodeCounter
  CodeCounter + 1
  Next x
  Next y
  StopDrawing()

  edit\posx = 1
  edit\posy = 1
  edit\line = font\leny - 1

  CloseFont(FontID)

  SearchFreePixel(): ToolAutoWide(): ToolReField(-BordMin\LI, -BordMin\OB, -BordMin\RE, -BordMin\UN)

EndProcedure

;----------------------------------
; Ende der Datei
;----------------------------------
; ExecutableFormat=
; DisableDebugger
; EOF